CodeForces 567D One-Dimensional Battle Ships【二分】

来源:互联网 发布:网络层协议 编辑:程序博客网 时间:2024/05/22 12:14

D. One-Dimensional Battle Ships
time limit per test
1 second
memory limit per test
256 megabytes
input
standard input
output
standard output

Alice and Bob love playing one-dimensional battle ships. They play on the field in the form of a line consisting ofn square cells (that is, on a 1 × n table).

At the beginning of the game Alice puts k ships on the field without telling their positions to Bob. Each ship looks as a1 × a rectangle (that is, it occupies a sequence ofa consecutive squares of the field). The ships cannot intersect and even touch each other.

After that Bob makes a sequence of "shots". He names cells of the field and Alice either says that the cell is empty ("miss"), or that the cell belongs to some ship ("hit").

But here's the problem! Alice like to cheat. May be that is why she responds to each Bob's move with a "miss".

Help Bob catch Alice cheating — find Bob's first move, such that after it you can be sure that Alice cheated.

Input

The first line of the input contains three integers: n,k and a (1 ≤ n, k, a ≤ 2·105) — the size of the field, the number of the ships and the size of each ship. It is guaranteed that the n,k and a are such that you can putk ships of size a on the field, so that no two ships intersect or touch each other.

The second line contains integer m (1 ≤ m ≤ n) — the number of Bob's moves.

The third line contains m distinct integersx1, x2, ..., xm, wherexi is the number of the cell where Bob made thei-th shot. The cells are numbered from left to right from1 to n.

Output

Print a single integer — the number of such Bob's first move, after which you can be sure that Alice lied. Bob's moves are numbered from1 to m in the order the were made. If the sought move doesn't exist, then print "-1".

Examples
Input
11 3 354 8 6 1 11
Output
3
Input
5 1 321 5
Output
-1
Input
5 1 313
Output
1

题目大意:


一共有一个长度为1*N的一个河道,其中放置了K艘1*a长度的船,其中要求船的摆放不能重叠,还不能相邻,此时有N个提问,表示我现在要攻击一个格子,询问是否打中了,但是调皮的所有回答都是Miss.问第几个回复能够判定出来已经是说谎了。如果有可能没有说过谎,那么输出-1.


思路:


1、因为提问越多,其越可能撒谎,那么其具有一定的单调性(假设0代表没有说谎,1表示有说谎,其结果可能是这样的:00000000111111111),那么我们二分这个提问次数,作为当前判定的标准。


2、对应当前二分出来的提问数mid.我们暴力处理当前情况最多还能放几艘船,如果当前能够放置的船数小于了K,那么对应当前情况就是说谎了的情况,相反就是没有,我们根据结果,继续挑选二分区间即可,一直二分到最后,统计最后一次说谎的位子,如果没有统计到这个位子,那么输出-1;


Ac代码:

#include<stdio.h>#include<string.h>using namespace std;int p[200600];int vis[200600];int q,n,k,a;int Slove(int mid){    memset(vis,0,sizeof(vis));    for(int i=1;i<=mid;i++)    {        vis[p[i]]=1;    }    int contz=0;    int cont=0;    for(int i=1;i<=n;i++)    {        if(vis[i]==0)        {            cont++;            if(cont==a)            {                cont=0;                contz++;                i++;            }        }        else        {            cont=0;        }    }    if(contz<k)return 1;    else return 0;}int main(){    while(~scanf("%d%d%d",&n,&k,&a))    {        scanf("%d",&q);        for(int i=1;i<=q;i++)        {            scanf("%d",&p[i]);        }        int l=1;        int r=q;        int ans=-1;        while(r-l>=0)        {            int mid=(l+r)/2;            if(Slove(mid)==1)            {                ans=mid;                r=mid-1;            }            else l=mid+1;        }        printf("%d\n",ans);    }}






0 0